

#ifdef WIN32
#include <winsock2.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <time.h>

#ifdef SOLARIS
#include <unistd.h>
#endif

#ifndef WIN32
#include <fcntl.h>
#endif

#include "transfer.h"

void Usage(char *progname) {
    fprintf(stderr,"Usage\n%s -n [server] -p [port] -s [buffersize]\n",progname);
    fprintf(stderr,"\tserver is the IP address or name of Xport device\n");
    fprintf(stderr,"\tport is the TCP port to use\n");
    fprintf(stderr,"\ts is data block size in Kbytes\n");
    fprintf(stderr,"Defaults are localhost; 9000 and 16Kn");
    exit(1);
}

extern void dump (char *, int);
        
int main(int argc, char **argv) {

    char *Buffer;
    char SmallBuffer[1024];
    char *Xport = (char*) "localhost";
    char *filename = NULL;
    int Port=9000;
    int verbose=0;
    int s;
    int BufferSize=16*1024;
    int SndBufSize=512;
    int i, j, len, Len;
    int cmd;

#ifndef WIN32
    int fh;
#else
    HANDLE fh;
    DWORD bytesReturned;
#endif

    j = 0;
    len = 0;

//printf("argc = %d\n", argc);

    if (argc >1) {
        for(i=1;i <argc;i++) {
            if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
                switch(tolower(argv[i][1])) {
                    case 'n':
                        Xport = argv[++i];
                        break;
                    case 'p':
                        Port = atoi(argv[++i]);
                        break;
                    case 's':
                        BufferSize = atoi(argv[++i])*1024;
                        break;
                    case 'w':
                        SndBufSize = atoi(argv[++i]);
                        break;
                    case 'v':
                        verbose = atoi(argv[++i]);
                        break;
                    case 'f':
                        filename = argv[++i];
                        break;
                    case '?':
                    default:
                        Usage(argv[0]);
                        break;
                }
            } else {
                SmallBuffer[j] = (unsigned char) strtol(argv[i], (char**)NULL, 0);
                j++; len++;
            }
        }
    }

     Buffer = (char *)malloc(BufferSize);
     if (len > 0) memcpy (Buffer, SmallBuffer, len);

    (void) XportSetVerbose(verbose);
//    (void) XportBlockSize(BufferSize);
//    (void) XportSndBufSize(SndBufSize);
    (void) XportPort(Port);
    (void) XportInit(Xport);

      if (filename != NULL) {

#ifndef WIN32
          fh = open(filename, O_RDONLY, 0);
          if (fh == -1) {perror(NULL); printf("open failed\n"); exit(16);}
#else
 
          fh = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
          if (fh == INVALID_HANDLE_VALUE) {report_Error(); exit(16);}
#endif      
                                  
          if (verbose) printf ("open OK\n");

#ifndef WIN32
          s= read (fh, &Buffer[j], BufferSize-len);
          if (s <= 0) {perror(NULL); printf("read failed\n"); exit(16);}
          len +=s;
#else
          s = ReadFile(fh, (LPVOID) Buffer, (DWORD) BufferSize, &bytesReturned, FALSE);
          if (s == 0) {report_Error(); exit(16);}
#endif

          if (verbose) printf ("read OK\n");

#ifndef WIN32
          s= close (fh);
#else
          s = CloseFile(fh);
#endif

      }

       if (verbose) printf("Transfer %d bytes\n",len);

       if (verbose) {
           if (len > 48) {Len=48;} else {Len=len;}
           dump(Buffer, Len);
       }

       cmd = ((*Buffer) >> 5) & 3;   /* write=0; long write=1; read=2 */

       s = XportTxData ((char*)Buffer ,&len);

       if (s != 0) {
           if (verbose) printf("Done with code=%d\n", s);
       } else {
           if (verbose) printf("Received %d bytes\n",len);
       }

       printf("Buffer contains: ");
       if (len > 48) {Len=48;} else {Len=len;}
       dump(Buffer, Len);

       if (s != 0)  exit(s);

       switch (cmd) {
           case 0:   {printf("0x00 0x00 0x00 0x00\n");break;}
           case 1:   {printf("0x00 0x00 0x00 0x00\n");break;}
           case 2:   {printf("0x00 0x00 0x00 0x00\n");break;}
           default:  {}
       }

      exit(0);
}
