

#ifdef WIN32
#include <winsock2.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <time.h>

#ifdef SOLARIS
#include <unistd.h>
#endif

#ifndef WIN32
#include <fcntl.h>
#endif

#include "transfer.h"

void Usage(char *progname) {
    fprintf(stderr,"Usage\n%s -n [server] -p [port] -s [buffersize]\n",progname);
    fprintf(stderr,"\tserver is the IP address or name of Xport device\n");
    fprintf(stderr,"\ts is data block size in Kbytes\n");
    fprintf(stderr,"Defaults are localhost and 16Kn");
    exit(1);
}
        
int main(int argc, char **argv) {

    char Buffer[100];
    char *Xport = (char*) "localhost";
    int verbose=0;
    int s;
    int BufferSize=16*1024;
    int SndBufSize=512;
    int i, j, len, Len;
    int cmd;

#ifndef WIN32
    int fh;
#else
    HANDLE fh;
    DWORD bytesReturned;
#endif

    j = 0;
    len = 0;

//printf("argc = %d\n", argc);

    if (argc >1) {
        for(i=1;i <argc;i++) {
            if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
                switch(tolower(argv[i][1])) {
                    case 'n':
                        Xport = argv[++i];
                        break;
                     case 's':
                        BufferSize = atoi(argv[++i])*1024;
                        break;
                    case 'w':
                        SndBufSize = atoi(argv[++i]);
                        break;
                    case 'v':
                        verbose = atoi(argv[++i]);
                        break;
                    case '?':
                    default:
                        Usage(argv[0]);
                        break;
                }
            } else {
                Usage(argv[0]);
            }
        }
    }

     Buffer[0] = 0xc0;
     Buffer[1] = 0;
     Buffer[2] = 0;
     Buffer[3] = 4;
     Buffer[4] = 0xd0;
     Buffer[5] = 13;
     Buffer[6] = 0;
     Buffer[7] = 0;

     len = 8;

    (void) XportSetVerbose(verbose);
//    (void) XportBlockSize(BufferSize);
//    (void) XportSndBufSize(SndBufSize);
    (void) XportInit(Xport);


       if (verbose) printf("Transfer %d bytes\n",len);

       if (verbose) {
           if (len > 48) {Len=48;} else {Len=len;}
           dump(Buffer, Len);
       }

       s = XportTxData ((char*)Buffer ,&len);

       if (s != 0) {
           if (verbose) printf("Done with code=%d\n", s);
       } else {
           if (verbose) printf("Received %d bytes\n",len);
       }

       printf("Buffer contains: ");
       if (len > 48) {Len=48;} else {Len=len;}
       dump(Buffer, Len);

      exit(0);
}
