#ifndef INCXporth
#define INCXporth

#define byte char

typedef struct header {              /* format of command/ack header  */
        byte hdr_destination; 
        byte hdr_length0;
        byte hdr_length1;
        byte hdr_length2;
} HEADER;


typedef struct write_request {              /* format of simple write request  */
        byte wrt_destination; 
        byte wrt_length0;
        byte wrt_length1;
        byte wrt_length2;
        byte wrt_command0;
        byte wrt_command1;
        byte wrt_data0;
        byte wrt_data1;
} WRITEREQUEST;

typedef struct read_request {              /* format of read request  */
        byte rd_destination; 
        byte rd_length0;
        byte rd_length1;
        byte rd_length2;
        byte rd_command0;
        byte rd_command1;
        byte rd_data0;
        byte rd_data1;
} READREQUEST;

typedef struct write_ack {              /* format of simple write ack  */
        byte wrtack_destination; 
        byte wrtack_length0;
        byte wrtack_length1;
        byte wrtack_length2;
} WRITEACK;

typedef struct write_nack {              /* format of simple failed write ack  */
        byte wrtnack_destination; 
        byte wrtnack_length0;
        byte wrtnack_length1;
        byte wrtnack_length2;
        byte wrtnack_command0;
        byte wrtnack_command1;
} WRITENACK;

typedef struct read_nack {              /* format of failed read ack  */
        byte rdnack_destination; 
        byte rdnack_length0;
        byte rdnack_length1;
        byte rdnack_length2;
        byte rdnack_command0;
        byte rdnack_command1;
} READNACK;

        
int XportTxData (unsigned char *, int *);
int XportBlockSize(int);
int XportPort(int);
int XportInit (char *);
void XportClose ();
int XportSetVerbose(int);
int XportSetUser(int);
int XportSndBufSize(int);
int XportRcvBufSize(int);
int XportSendTimeout(int);
int XportRecvTimeout(int);
void XportResetAll();
void XportReset();

#endif
